var request = require("request");
var jetpack = require("fs-jetpack");
var opn = require("opn");
var os = require("os");

var unzip = require("unzip");
var pat = require("path");
var fs = require("fs");
var rt = jetpack.cwd(pat.join(os.homedir(),".hq"))


const install = (cb) => new Promise((resolve, reject) => {
  var wait = cb ? cb() : Promise.resolve();
  wait.then(() => {
    rt.file(".touch");
    var r = request("https://download.rethinkdb.com/windows/rethinkdb-2.3.5.zip")
    r.pipe(unzip.Extract({ path: rt.path("rethink") }))
    r.on("end",function(){
      resolve()
    })
  })
})

var spawn = require('cross-spawn');

const run = () => new Promise((resolve, reject) => {
  //  spawn.on('error', reject)
  var s = spawn(rt.path(pat.join("rethink","rethinkdb.exe")), [], {cwd : pat.join(os.homedir(),".hq")});
  s.on('error',reject)
  s.stdio[1].on('data', function(d){
    if (d.toString().indexOf("Server ready,") >= 0) resolve()
  })
})

const init = (cb) => run().catch(e => install(cb).then(run)).then(() => console.log("rethink done"))

module.exports = {
  start : init,
  install : () => Promise.resolve()
}
